<html>
<head>
<title>Ogre::GLESPixelUtil Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GLESPixelUtil.html">GLESPixelUtil</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GLESPixelUtil Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GLESPixelUtil" -->
<p>Class to do pixel format mapping between GL and OGRE.  
 <a href="classOgre_1_1GLESPixelUtil.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGLESPixelFormat_8h_source.html">OgreGLESPixelFormat.h</a>&gt;</code></p>

<p><a href="classOgre_1_1GLESPixelUtil-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a275c932571ef41b3c0d404be8283ba17">getGLOriginFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the appropriate GL one.  <a href="#a275c932571ef41b3c0d404be8283ba17"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a754201f1421d03447a05efacbade33d8">getGLOriginDataType</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns type that must be provided to GL as data type for reading it into the GPU.  <a href="#a754201f1421d03447a05efacbade33d8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a9252f19f3c151cead8ffac38ddbe874d">getGLInternalFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat, bool hwGamma=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the type that must be provided to GL as internal format.  <a href="#a9252f19f3c151cead8ffac38ddbe874d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static GLenum&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a0c23fc750b48401e7b0d4254f32209ad">getClosestGLInternalFormat</a> (<a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> mFormat, bool hwGamma=false)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes the OGRE pixel format and returns the type that must be provided to GL as internal format.  <a href="#a0c23fc750b48401e7b0d4254f32209ad"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a160f18eb5b791bab2505278973ef1203">getClosestOGREFormat</a> (GLenum fmt, GLenum dataType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to get the closest matching OGRE format to an internal GL format.  <a href="#a160f18eb5b791bab2505278973ef1203"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#ad1c3306a8ec75c3ad19044393c1322ea">getMaxMipmaps</a> (size_t width, size_t height, size_t depth, <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> format)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum number of Mipmaps that can be generated until we reach the mininum format possible.  <a href="#ad1c3306a8ec75c3ad19044393c1322ea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a0f01e5e241cc212ac18918dd5bfde94a">optionalPO2</a> (size_t value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns next power-of-two size if required by render system, in case RSC_NON_POWER_OF_2_TEXTURES is supported it returns value as-is.  <a href="#a0f01e5e241cc212ac18918dd5bfde94a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLESPixelUtil.html#a828a7774c8462b3db030be4e7ad40f05">convertToGLformat</a> (const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;src, const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;dst)</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class to do pixel format mapping between GL and OGRE. </p>

<p>Definition at line <a class="el" href="OgreGLESPixelFormat_8h_source.html#l00040">40</a> of file <a class="el" href="OgreGLESPixelFormat_8h_source.html">OgreGLESPixelFormat.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a828a7774c8462b3db030be4e7ad40f05"></a><!-- doxytag: member="Ogre::GLESPixelUtil::convertToGLformat" ref="a828a7774c8462b3db030be4e7ad40f05" args="(const PixelBox &amp;src, const PixelBox &amp;dst)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1GLESPixelUtil.html#a828a7774c8462b3db030be4e7ad40f05">Ogre::GLESPixelUtil::convertToGLformat</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1PixelBox.html">PixelBox</a> &amp;&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a0c23fc750b48401e7b0d4254f32209ad"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getClosestGLInternalFormat" ref="a0c23fc750b48401e7b0d4254f32209ad" args="(PixelFormat mFormat, bool hwGamma=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLESPixelUtil.html#a0c23fc750b48401e7b0d4254f32209ad">Ogre::GLESPixelUtil::getClosestGLInternalFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>hwGamma</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the type that must be provided to GL as internal format. </p>
<p>If no match exists, returns the closest match. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mFormat</td><td>The pixel format </td></tr>
    <tr><td class="paramname">hwGamma</td><td>Whether a hardware gamma-corrected version is requested </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a160f18eb5b791bab2505278973ef1203"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getClosestOGREFormat" ref="a160f18eb5b791bab2505278973ef1203" args="(GLenum fmt, GLenum dataType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a> <a class="el" href="classOgre_1_1GLESPixelUtil.html#a160f18eb5b791bab2505278973ef1203">Ogre::GLESPixelUtil::getClosestOGREFormat</a> </td>
          <td>(</td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>dataType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function to get the closest matching OGRE format to an internal GL format. </p>
<p>To be precise, the format will be chosen that is most efficient to transfer to the card without losing precision. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>It is valid for this function to always return PF_A8R8G8B8. </dd></dl>

</div>
</div>
<a class="anchor" id="a9252f19f3c151cead8ffac38ddbe874d"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getGLInternalFormat" ref="a9252f19f3c151cead8ffac38ddbe874d" args="(PixelFormat mFormat, bool hwGamma=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLESPixelUtil.html#a9252f19f3c151cead8ffac38ddbe874d">Ogre::GLESPixelUtil::getGLInternalFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>hwGamma</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the type that must be provided to GL as internal format. </p>
<p>GL_NONE if no match exists. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mFormat</td><td>The pixel format </td></tr>
    <tr><td class="paramname">hwGamma</td><td>Whether a hardware gamma-corrected version is requested </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a754201f1421d03447a05efacbade33d8"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getGLOriginDataType" ref="a754201f1421d03447a05efacbade33d8" args="(PixelFormat mFormat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLESPixelUtil.html#a754201f1421d03447a05efacbade33d8">Ogre::GLESPixelUtil::getGLOriginDataType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns type that must be provided to GL as data type for reading it into the GPU. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>a GLenum describing the data type, or 0 if there is no exactly matching one (and conversion is needed) </dd></dl>

</div>
</div>
<a class="anchor" id="a275c932571ef41b3c0d404be8283ba17"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getGLOriginFormat" ref="a275c932571ef41b3c0d404be8283ba17" args="(PixelFormat mFormat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static GLenum <a class="el" href="classOgre_1_1GLESPixelUtil.html#a275c932571ef41b3c0d404be8283ba17">Ogre::GLESPixelUtil::getGLOriginFormat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>mFormat</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes the OGRE pixel format and returns the appropriate GL one. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>a GLenum describing the format, or 0 if there is no exactly matching one (and conversion is needed) </dd></dl>

</div>
</div>
<a class="anchor" id="ad1c3306a8ec75c3ad19044393c1322ea"></a><!-- doxytag: member="Ogre::GLESPixelUtil::getMaxMipmaps" ref="ad1c3306a8ec75c3ad19044393c1322ea" args="(size_t width, size_t height, size_t depth, PixelFormat format)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t <a class="el" href="classOgre_1_1GLESPixelUtil.html#ad1c3306a8ec75c3ad19044393c1322ea">Ogre::GLESPixelUtil::getMaxMipmaps</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>depth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c">PixelFormat</a>&#160;</td>
          <td class="paramname"><em>format</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the maximum number of Mipmaps that can be generated until we reach the mininum format possible. </p>
<p>This does not count the base level. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>The width of the area </td></tr>
    <tr><td class="paramname">height</td><td>The height of the area </td></tr>
    <tr><td class="paramname">depth</td><td>The depth of the area </td></tr>
    <tr><td class="paramname">format</td><td>The format of the area </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>In case that the format is non-compressed, this simply returns how many times we can divide this texture in 2 until we reach 1x1. For compressed formats, constraints apply on minimum size and alignment so this might differ. </dd></dl>

</div>
</div>
<a class="anchor" id="a0f01e5e241cc212ac18918dd5bfde94a"></a><!-- doxytag: member="Ogre::GLESPixelUtil::optionalPO2" ref="a0f01e5e241cc212ac18918dd5bfde94a" args="(size_t value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static size_t <a class="el" href="classOgre_1_1GLESPixelUtil.html#a0f01e5e241cc212ac18918dd5bfde94a">Ogre::GLESPixelUtil::optionalPO2</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns next power-of-two size if required by render system, in case RSC_NON_POWER_OF_2_TEXTURES is supported it returns value as-is. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGLESPixelFormat_8h_source.html">OgreGLESPixelFormat.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:25
</p>
</body>
</html>
